# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.DateShiftConfig do
  @moduledoc """
  Shift a date forward or backward in time by a random amount which is
  consistent for a given patient and crypto key combination.

  ## Attributes

  *   `cryptoKey` (*type:* `String.t`, *default:* `nil`) - An AES 128/192/256 bit key. Causes the shift to be computed based on this
      key and the patient ID. A default key is generated for each
      Deidentify operation and is used wherever crypto_key is not specified.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :cryptoKey => String.t()
        }

  field(:cryptoKey)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.DateShiftConfig do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.DateShiftConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.DateShiftConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
