# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.DicomFilterConfig do
  @moduledoc """
  Specifies the filter configuration for DICOM resources.

  ## Attributes

  *   `resourcePathsGcsUri` (*type:* `String.t`, *default:* `nil`) - The Cloud Storage location of the filter configuration file.
      The `gcs_uri` must be in the format `gs://bucket/path/to/object`.
      The filter configuration file must contain a list of resource paths
      separated by newline characters (\\n or \\r\\n). Each resource path
      must be in the format
      "/studies/{studyUID}[/series/{seriesUID}[/instances/{instanceUID}]]"

      The Cloud Healthcare API service account must have the
      `roles/storage.objectViewer` Cloud IAM role for this Cloud Storage
      location.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :resourcePathsGcsUri => String.t()
        }

  field(:resourcePathsGcsUri)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.DicomFilterConfig do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.DicomFilterConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.DicomFilterConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
