# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.FieldMetadata do
  @moduledoc """
  Specifies FHIR paths to match, and how to handle de-identification of
  matching fields.

  ## Attributes

  *   `action` (*type:* `String.t`, *default:* `nil`) - Deidentify action for one field.
  *   `paths` (*type:* `list(String.t)`, *default:* `nil`) - List of paths to FHIR fields to redact. Each path is a
      period-separated list where each component is either a field name or
      FHIR type name. All types begin with an upper case letter. For example,
      the resource field "Patient.Address.city", which uses a string type,
      can be matched by "Patient.Address.String". Path also supports partial
      matching. For example, "Patient.Address.city" can be matched by
      "Address.city" (Patient omitted). Partial matching and type matching
      can be combined. For example, "Patient.Address.city" can be matched by
      "Address.String". For "choice" types (those defined in the FHIR spec
      with the form: field[x]), use two separate components. For example,
      "deceasedAge.unit" is matched by "Deceased.Age.unit". Supported types
      are: AdministrativeGenderCode, Code, Date, DateTime, Decimal,
      HumanName, Id, LanguageCode, Markdown, Oid, String, Uri, Uuid, Xhtml.
      The sub-type for HumanName, such as HumanName.given or
      HumanName.family, can be omitted.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :action => String.t(),
          :paths => list(String.t())
        }

  field(:action)
  field(:paths, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.FieldMetadata do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.FieldMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.FieldMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
