# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.ImportAnnotationsErrorDetails do
  @moduledoc """
  Final response of importing
  Annotations in
  partial or total failure case. This structure is included in the
  error
  details. It is only included when the operation
  finishes.

  ## Attributes

  *   `annotationStore` (*type:* `String.t`, *default:* `nil`) - The annotation_store that the annotations were imported to. The name
      is in the format
      `projects/{project_id}/locations/{location_id}/datasets/{dataset_id}/annotationStores/{annotation_store_id}`.
  *   `errorCount` (*type:* `String.t`, *default:* `nil`) - The number of annotations that had errors.
  *   `successCount` (*type:* `String.t`, *default:* `nil`) - The number of annotations that have been imported.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :annotationStore => String.t(),
          :errorCount => String.t(),
          :successCount => String.t()
        }

  field(:annotationStore)
  field(:errorCount)
  field(:successCount)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.ImportAnnotationsErrorDetails do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.ImportAnnotationsErrorDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.ImportAnnotationsErrorDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
